#!/usr/bin/env python2
#
# numeric.py - IRC numerics stuff
# Taken from charybdis numeric.h with a horrible shell script
# Dedicated to the public domain.

# TODO: annotate

import sys

numeric_to_name = {
    "001" : "RPL_WELCOME",
    "002" : "RPL_YOURHOST",
    "003" : "RPL_CREATED",
    "004" : "RPL_MYINFO",
    "005" : "RPL_ISUPPORT",
    "008" : "RPL_SNOMASK",
    "010" : "RPL_REDIR",
    "015" : "RPL_MAP",
    "016" : "RPL_MAPMORE",
    "017" : "RPL_MAPEND",
    "043" : "RPL_SAVENICK",
    "200" : "RPL_TRACELINK",
    "201" : "RPL_TRACECONNECTING",
    "202" : "RPL_TRACEHANDSHAKE",
    "203" : "RPL_TRACEUNKNOWN",
    "204" : "RPL_TRACEOPERATOR",
    "205" : "RPL_TRACEUSER",
    "206" : "RPL_TRACESERVER",
    "208" : "RPL_TRACENEWTYPE",
    "209" : "RPL_TRACECLASS",
    "211" : "RPL_STATSLINKINFO",
    "212" : "RPL_STATSCOMMANDS",
    "213" : "RPL_STATSCLINE",
    "214" : "RPL_STATSNLINE",
    "215" : "RPL_STATSILINE",
    "216" : "RPL_STATSKLINE",
    "217" : "RPL_STATSQLINE",
    "218" : "RPL_STATSYLINE",
    "219" : "RPL_ENDOFSTATS",
    "220" : "RPL_STATSPLINE",
    "221" : "RPL_UMODEIS",
    "224" : "RPL_STATSFLINE",
    "225" : "RPL_STATSDLINE",
    "234" : "RPL_SERVLIST",
    "235" : "RPL_SERVLISTEND",
    "241" : "RPL_STATSLLINE",
    "242" : "RPL_STATSUPTIME",
    "243" : "RPL_STATSOLINE",
    "244" : "RPL_STATSHLINE",
    "245" : "RPL_STATSSLINE",
    "247" : "RPL_STATSXLINE",
    "248" : "RPL_STATSULINE",
    "249" : "RPL_STATSDEBUG",
    "250" : "RPL_STATSCONN",
    "251" : "RPL_LUSERCLIENT",
    "252" : "RPL_LUSEROP",
    "253" : "RPL_LUSERUNKNOWN",
    "254" : "RPL_LUSERCHANNELS",
    "255" : "RPL_LUSERME",
    "256" : "RPL_ADMINME",
    "257" : "RPL_ADMINLOC1",
    "258" : "RPL_ADMINLOC2",
    "259" : "RPL_ADMINEMAIL",
    "261" : "RPL_TRACELOG",
    "262" : "RPL_ENDOFTRACE",
    "263" : "RPL_LOAD2HI",
    "265" : "RPL_LOCALUSERS",
    "266" : "RPL_GLOBALUSERS",
    "270" : "RPL_PRIVS",
    "276" : "RPL_WHOISCERTFP",
    "281" : "RPL_ACCEPTLIST",
    "282" : "RPL_ENDOFACCEPT",
    "300" : "RPL_NONE",
    "301" : "RPL_AWAY",
    "302" : "RPL_USERHOST",
    "303" : "RPL_ISON",
    "304" : "RPL_TEXT",
    "305" : "RPL_UNAWAY",
    "306" : "RPL_NOWAWAY",
    "310" : "RPL_WHOISHELPFUL",
    "311" : "RPL_WHOISUSER",
    "312" : "RPL_WHOISSERVER",
    "313" : "RPL_WHOISOPERATOR",
    "314" : "RPL_WHOWASUSER",
    "369" : "RPL_ENDOFWHOWAS",
    "316" : "RPL_WHOISCHANOP",
    "317" : "RPL_WHOISIDLE",
    "318" : "RPL_ENDOFWHOIS",
    "319" : "RPL_WHOISCHANNELS",
    "321" : "RPL_LISTSTART",
    "322" : "RPL_LIST",
    "323" : "RPL_LISTEND",
    "324" : "RPL_CHANNELMODEIS",
    "325" : "RPL_CHANNELMLOCK",
    "328" : "RPL_CHANNELURL",
    "329" : "RPL_CREATIONTIME",
    "330" : "RPL_WHOISLOGGEDIN",
    "331" : "RPL_NOTOPIC",
    "332" : "RPL_TOPIC",
    "333" : "RPL_TOPICWHOTIME",
    "338" : "RPL_WHOISACTUALLY",
    "341" : "RPL_INVITING",
    "342" : "RPL_SUMMONING",
    "346" : "RPL_INVITELIST",
    "347" : "RPL_ENDOFINVITELIST",
    "348" : "RPL_EXCEPTLIST",
    "349" : "RPL_ENDOFEXCEPTLIST",
    "351" : "RPL_VERSION",
    "352" : "RPL_WHOREPLY",
    "354" : "RPL_WHOSPCRPL",
    "315" : "RPL_ENDOFWHO",
    "353" : "RPL_NAMREPLY",
    "360" : "RPL_WHOWASREAL",
    "366" : "RPL_ENDOFNAMES",
    "361" : "RPL_KILLDONE",
    "362" : "RPL_CLOSING",
    "363" : "RPL_CLOSEEND",
    "364" : "RPL_LINKS",
    "365" : "RPL_ENDOFLINKS",
    "367" : "RPL_BANLIST",
    "368" : "RPL_ENDOFBANLIST",
    "371" : "RPL_INFO",
    "372" : "RPL_MOTD",
    "373" : "RPL_INFOSTART",
    "374" : "RPL_ENDOFINFO",
    "375" : "RPL_MOTDSTART",
    "376" : "RPL_ENDOFMOTD",
    "378" : "RPL_WHOISHOST",
    "379" : "RPL_WHOISMODES",
    "381" : "RPL_YOUREOPER",
    "382" : "RPL_REHASHING",
    "384" : "RPL_MYPORTIS",
    "385" : "RPL_NOTOPERANYMORE",
    "386" : "RPL_RSACHALLENGE",
    "391" : "RPL_TIME",
    "392" : "RPL_USERSSTART",
    "393" : "RPL_USERS",
    "394" : "RPL_ENDOFUSERS",
    "395" : "RPL_NOUSERS",
    "396" : "RPL_HOSTHIDDEN",
    "401" : "ERR_NOSUCHNICK",
    "402" : "ERR_NOSUCHSERVER",
    "403" : "ERR_NOSUCHCHANNEL",
    "404" : "ERR_CANNOTSENDTOCHAN",
    "405" : "ERR_TOOMANYCHANNELS",
    "406" : "ERR_WASNOSUCHNICK",
    "407" : "ERR_TOOMANYTARGETS",
    "409" : "ERR_NOORIGIN",
    "410" : "ERR_INVALIDCAPCMD",
    "411" : "ERR_NORECIPIENT",
    "412" : "ERR_NOTEXTTOSEND",
    "413" : "ERR_NOTOPLEVEL",
    "414" : "ERR_WILDTOPLEVEL",
    "416" : "ERR_TOOMANYMATCHES",
    "421" : "ERR_UNKNOWNCOMMAND",
    "422" : "ERR_NOMOTD",
    "423" : "ERR_NOADMININFO",
    "424" : "ERR_FILEERROR",
    "431" : "ERR_NONICKNAMEGIVEN",
    "432" : "ERR_ERRONEUSNICKNAME",
    "433" : "ERR_NICKNAMEINUSE",
    "435" : "ERR_BANNICKCHANGE",
    "436" : "ERR_NICKCOLLISION",
    "437" : "ERR_UNAVAILRESOURCE",
    "438" : "ERR_NICKTOOFAST",
    "440" : "ERR_SERVICESDOWN",
    "441" : "ERR_USERNOTINCHANNEL",
    "442" : "ERR_NOTONCHANNEL",
    "443" : "ERR_USERONCHANNEL",
    "444" : "ERR_NOLOGIN",
    "445" : "ERR_SUMMONDISABLED",
    "446" : "ERR_USERSDISABLED",
    "447" : "ERR_NOINVITE",
    "449" : "ERR_NONICK",
    "451" : "ERR_NOTREGISTERED",
    "456" : "ERR_ACCEPTFULL",
    "457" : "ERR_ACCEPTEXIST",
    "458" : "ERR_ACCEPTNOT",
    "461" : "ERR_NEEDMOREPARAMS",
    "462" : "ERR_ALREADYREGISTRED",
    "463" : "ERR_NOPERMFORHOST",
    "464" : "ERR_PASSWDMISMATCH",
    "465" : "ERR_YOUREBANNEDCREEP",
    "466" : "ERR_YOUWILLBEBANNED",
    "467" : "ERR_KEYSET",
    "470" : "ERR_LINKCHANNEL",
    "471" : "ERR_CHANNELISFULL",
    "472" : "ERR_UNKNOWNMODE",
    "473" : "ERR_INVITEONLYCHAN",
    "474" : "ERR_BANNEDFROMCHAN",
    "475" : "ERR_BADCHANNELKEY",
    "476" : "ERR_BADCHANMASK",
    "477" : "ERR_NEEDREGGEDNICK",
    "478" : "ERR_BANLISTFULL",
    "479" : "ERR_BADCHANNAME",
    "480" : "ERR_THROTTLE",
    "481" : "ERR_NOPRIVILEGES",
    "482" : "ERR_CHANOPRIVSNEEDED",
    "483" : "ERR_CANTKILLSERVER",
    "484" : "ERR_ISCHANSERVICE",
    "485" : "ERR_BANNEDNICK",
    "486" : "ERR_NONONREG",
    "489" : "ERR_VOICENEEDED",
    "491" : "ERR_NOOPERHOST",
    "492" : "ERR_NOCTCP",
    "495" : "ERR_KICKNOREJOIN",
    "494" : "ERR_OWNMODE",
    "501" : "ERR_UMODEUNKNOWNFLAG",
    "502" : "ERR_USERSDONTMATCH",
    "503" : "ERR_GHOSTEDCLIENT",
    "504" : "ERR_USERNOTONSERV",
    "513" : "ERR_WRONGPONG",
    "517" : "ERR_DISABLED",
    "519" : "ERR_NOKICK",
    "524" : "ERR_HELPNOTFOUND",
    "671" : "RPL_WHOISSECURE",
    "702" : "RPL_MODLIST",
    "703" : "RPL_ENDOFMODLIST",
    "704" : "RPL_HELPSTART",
    "705" : "RPL_HELPTXT",
    "706" : "RPL_ENDOFHELP",
    "707" : "ERR_TARGCHANGE",
    "708" : "RPL_ETRACEFULL",
    "709" : "RPL_ETRACE",
    "710" : "RPL_KNOCK",
    "711" : "RPL_KNOCKDLVR",
    "712" : "ERR_TOOMANYKNOCK",
    "713" : "ERR_CHANOPEN",
    "714" : "ERR_KNOCKONCHAN",
    "715" : "ERR_KNOCKDISABLED",
    "716" : "ERR_TARGUMODEG",
    "717" : "RPL_TARGNOTIFY",
    "718" : "RPL_UMODEGMSG",
    "720" : "RPL_OMOTDSTART",
    "721" : "RPL_OMOTD",
    "722" : "RPL_ENDOFOMOTD",
    "723" : "ERR_NOPRIVS",
    "724" : "RPL_TESTMASK",
    "725" : "RPL_TESTLINE",
    "726" : "RPL_NOTESTLINE",
    "727" : "RPL_TESTMASKGECOS",
    "728" : "RPL_QUIETLIST",
    "729" : "RPL_ENDOFQUIETLIST",
    "730" : "RPL_MONONLINE",
    "731" : "RPL_MONOFFLINE",
    "732" : "RPL_MONLIST",
    "733" : "RPL_ENDOFMONLIST",
    "734" : "ERR_MONLISTFULL",
    "737" : "ERR_NOCOMMONCHAN",
    "740" : "RPL_RSACHALLENGE2",
    "741" : "RPL_ENDOFRSACHALLENGE2",
    "742" : "ERR_MLOCKRESTRICTED",
    "750" : "RPL_SCANMATCHED",
    "751" : "RPL_SCANUMODES",
    "900" : "RPL_LOGGEDIN",
    "901" : "RPL_LOGGEDOUT",
    "902" : "ERR_NICKLOCKED",
    "903" : "RPL_SASLSUCCESS",
    "904" : "ERR_SASLFAIL",
    "905" : "ERR_SASLTOOLONG",
    "906" : "ERR_SASLABORTED",
    "907" : "ERR_SASLALREADY",
    "934" : "ERR_CANTUSECENSOR",
    "935" : "ERR_INVALIDCENSOR",
    "937" : "ERR_ALREADYONCENSORLIST",
    "938" : "ERR_NOSUCHCENSOR",
    "939" : "ERR_CENSORLISTFULL",
    "940" : "RPL_CENSORLIST",
    "941" : "RPL_ENDOFCENSORLIST",
    "999" : "ERR_LAST_ERR_MSG",
}

# Worst hack ever.
this = sys.modules[__name__]
for num, name in numeric_to_name.items():
    setattr(this, name, num)
